﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

[Serializable()]
public class ShoppingCart
{

  private List<OrderedProduct> _items = new List<OrderedProduct>();

  public ShoppingCart()
  {
  }

  public int Count
  {
    get
    {
      int intQty = 0;
      foreach (OrderedProduct myOrderedProduct in _items)
      {
        intQty += myOrderedProduct.Quantity;
      }
      return intQty;
    }
  }

  public List<OrderedProduct> Items
  {
    get { return _items; }
  }

  public decimal Total
  {
    get
    {
      decimal decAmount = default(decimal);
      foreach (OrderedProduct myOrderedProduct in _items)
      {
        decAmount += myOrderedProduct.SubTotal;
      }
      return decAmount;
    }
  }

  public void Add(Product clsProduct)
  {
    foreach (OrderedProduct existingProduct in _items)
    {
      if (clsProduct.ID == existingProduct.ProductID)
      {
        existingProduct.Quantity += 1;
        return;
      }
    }
    OrderedProduct clsOrderedProduct = new OrderedProduct(clsProduct, 1);
    _items.Add(clsOrderedProduct);
  }

  public void Update(int intQuantity, Guid id)
  {
    foreach (OrderedProduct existingProduct in _items)
    {
      if (existingProduct.ID == id)
      {
        existingProduct.Quantity = intQuantity;
      }
    }
  }

  public void Remove(Guid id)
  {
    foreach (OrderedProduct existingProduct in _items)
    {
      if (id == existingProduct.ID)
      {
        _items.Remove(existingProduct);
        break; // TODO: might not be correct. Was : Exit For
      }
    }
  }

  public void Clear()
  {
    _items.Clear();
  }

}