﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="ShoppingCart.aspx.cs" Inherits="ShoppingCart" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
  <title>Shopping Cart</title>
  <link href="stylesheets/StyleSheet.css" rel="stylesheet" type="text/css" />
</head>
<body>
  <form id="form1" runat="server">
  <div id="content">

    <asp:GridView ID="gvCart" runat="server"  
      AutoGenerateColumns="False" 
      DataSourceID="odsCart"
      DataKeyNames="ID" 
      ShowFooter="True" 
      GridLines="Horizontal"
      BorderStyle="Solid" 
      BorderWidth="1px"
      CssClass="DataWebControlStyle" onrowdatabound="gvCart_RowDataBound">
      <AlternatingRowStyle CssClass="AlternatingRowStyle" />
      <RowStyle CssClass="RowStyle" />
      <HeaderStyle CssClass="HeaderStyle" />
      <FooterStyle CssClass="FooterStyle" />
      <SelectedRowStyle CssClass="SelectedRowStyle" />
      <PagerStyle CssClass="PagerRowStyle" />
      <PagerSettings Mode="NumericFirstLast" PageButtonCount="5" />         
      <Columns>
        <asp:ImageField DataImageUrlField="PictureUrlSmall" ShowHeader="False" ReadOnly="True">
        </asp:ImageField>  
        <asp:BoundField DataField="Title" HeaderText="商品名" ReadOnly="True" SortExpression="Title">
          <ItemStyle Width="460px" VerticalAlign="Middle" />
          <HeaderStyle HorizontalAlign="Left" />
        </asp:BoundField>
        <asp:TemplateField HeaderText="数量" SortExpression="Quantity">
          <ItemTemplate>
            <asp:Label ID="lblQuantity" runat="server" Text='<%# Eval("Quantity") %>'></asp:Label>
          </ItemTemplate>
          <EditItemTemplate>
            <asp:DropDownList ID="dropQuantity" runat="server" 
              SelectedValue='<%# Eval("Quantity") %>'>
              <asp:ListItem Value="1" Selected="True">1</asp:ListItem>
              <asp:ListItem Value="2">2</asp:ListItem>
              <asp:ListItem Value="3">3</asp:ListItem>
              <asp:ListItem Value="4">4</asp:ListItem>
              <asp:ListItem Value="5">5</asp:ListItem>
              <asp:ListItem Value="6">6</asp:ListItem>
              <asp:ListItem Value="7">7</asp:ListItem>
              <asp:ListItem Value="8">8</asp:ListItem>
              <asp:ListItem Value="9">9</asp:ListItem>
              <asp:ListItem Value="10">10</asp:ListItem>
            </asp:DropDownList>
          </EditItemTemplate>
          <ItemStyle HorizontalAlign="Right" Width="60px" VerticalAlign="Middle" />
          <HeaderStyle HorizontalAlign="Right" />
        </asp:TemplateField>
        <asp:BoundField DataField="Price" HeaderText="価格" HtmlEncode="False" ReadOnly="True" SortExpression="Price"
          DataFormatString="{0:n0}円">
          <ItemStyle HorizontalAlign="Right" Width="75px" VerticalAlign="Middle" />
          <HeaderStyle HorizontalAlign="Right" />
        </asp:BoundField>
        <asp:BoundField DataField="SubTotal" HeaderText="小計" HtmlEncode="False" ReadOnly="True" SortExpression="SubTotal"
          DataFormatString="{0:n0}円">
          <ItemStyle HorizontalAlign="Right" Width="75px" VerticalAlign="Middle" />
          <HeaderStyle HorizontalAlign="Right" />
        </asp:BoundField>
        <asp:TemplateField ShowHeader="False">
          <ItemStyle HorizontalAlign="Center" Width="50px" />
          <ItemTemplate>
            <asp:Button ID="btnDelete" runat="server" CausesValidation="False" 
              CommandName="Delete" Text="削除" 
              OnClientClick="return confirm('カートから商品を削除してよろしいですか？');" />
          </ItemTemplate>
          <EditItemTemplate></EditItemTemplate>
        </asp:TemplateField>
        <asp:TemplateField ShowHeader="False" Visible="true">
          <ItemTemplate>
            <asp:Button ID="Button1" runat="server" CausesValidation="False" 
              CommandName="Edit" Text="編集">
            </asp:Button>
          </ItemTemplate>
          <EditItemTemplate>
            <asp:Button ID="Button2" runat="server" CausesValidation="False" 
              CommandName="Update" Text="更新">
            </asp:Button>      
            <asp:Button ID="Button3" runat="server" CausesValidation="False" 
              CommandName="Cancel" Text="中止">
            </asp:Button>
          </EditItemTemplate>
          <ItemStyle Width="50px" HorizontalAlign="Center" />
        </asp:TemplateField>
      </Columns>
    </asp:GridView> 
 
    <asp:Button ID="btnContinue" runat="Server" Text="買い物を続ける" 
      onclick="btnContinue_Click" />
    &nbsp;
    <asp:Button ID="btnCheckout" runat="server" Text="注文画面に進む" Enabled="false" 
      onclick="btnCheckout_Click" />
  
  </div>
  
  <asp:ObjectDataSource ID="odsCart" runat="server" 
    TypeName="ShopManager" 
    SelectMethod="GetShoppingCartItems"
    UpdateMethod="UpdateProductInCart"
    DeleteMethod="RemoveProductFromCart" onupdating="odsCart_Updating">
    <UpdateParameters>
      <asp:Parameter Name="newQuantity" Type="Int32" />
    </UpdateParameters>  
  </asp:ObjectDataSource>
  
  </form>
</body>
</html>
