﻿$(function() {
  var $books = $('#books'), $cart = $('#cart');

  $('li', $books).draggable({
    cancel: 'a.ui-icon',  // clicking an icon won't initiate dragging
    revert: 'invalid',    // when not dropped, the item will revert back to its initial position
    containment: $('#demo-frame').length ? '#demo-frame' : 'document', // stick to demo-frame if present
    helper: 'clone',
    cursor: 'move'
  });

  $cart.droppable({
    accept: '#books > li',
    activeClass: 'ui-state-highlight',
    drop: function(ev, ui) {
      deleteImage(ui.draggable);
    }
  });

  $books.droppable({
    accept: '#cart li',
    activeClass: 'custom-state-active',
    drop: function(ev, ui) {
      recycleImage(ui.draggable);
    }
  });

  // image deletion function
  var recycle_icon = '<a href="#nogo" title="かごから戻す" class="ui-icon ui-icon-refresh">この本をかごから戻す</a>';
  //var recycle_icon = '<a href="#nogo" title="Recycle this book" class="ui-icon ui-icon-refresh">Recycle book</a>';

  function deleteImage($item) {
    $item.fadeOut(function() {
      var $list = $('ul', $cart).length ? $('ul', $cart) : $('<ul class="books ui-helper-reset"/>').appendTo($cart);

      $item.find('a.ui-icon-cart').remove();
      $item.append(recycle_icon).appendTo($list).fadeIn(function() {
        $item.animate({ width: '48px' }).find('img').animate({ height: '60px' });
      });
    });
  }

  // image recycle function
  var cart_icon = '<a href="#nogo" title="かごに入れる" class="ui-icon ui-icon-cart">この本をかごに入れる</a>';
  //var cart_icon = '<a href="#nogo" title="Add to Shopping Cart" class="ui-icon ui-icon-cart">Add this book</a>';


  function recycleImage($item) {
    $item.fadeOut(function() {
      $item.find('a.ui-icon-refresh').remove();
      $item.css('width', '96px').append(cart_icon).find('img').css('height', '120px').end().appendTo($books).fadeIn();
    });
  }

  // image preview function, demonstrating the ui.dialog used as a modal window
  function viewLargerImage($link) {
    var src = $link.attr('href');
    var title = $link.siblings('img').attr('alt');
    var $modal = $('img[src$="' + src + '"]');

    $modal.length ? $modal.dialog('open') : $('<img alt="' + title + '" width="384" height="288" style="padding: 8px;" />').attr('src', src).appendTo('body').dialog({
      title: title,
      width: '440px', // 400px
      modal: 'true',
      overlay: {
        backgroundColor: '#000',
        opacity: 0.5
      }
    });
  }

  // resolve the icons behavior with event delegation
  $('ul.books > li').click(function(ev) {
    var $item = $(this);
    var $target = $(ev.target);

    if ($target.is('a.ui-icon-cart')) {
      deleteImage($item);
    } else if ($target.is('a.ui-icon-zoomin')) {
      viewLargerImage($target);
    } else if ($target.is('a.ui-icon-refresh')) {
      recycleImage($item);
    }

    return false;
  });
});