﻿Imports Microsoft.VisualBasic
Imports System.Collections.Generic


<Serializable()> _
Public Class ShoppingCart

  Private _items As New List(Of OrderedProduct)

  Public Sub New()
  End Sub

  Public ReadOnly Property Count() As Integer
    Get
      Dim intQty As Integer
      For Each myOrderedProduct As OrderedProduct In _items
        intQty += myOrderedProduct.Quantity
      Next
      Return intQty
    End Get
  End Property

  Public ReadOnly Property Items() As List(Of OrderedProduct)
    Get
      Return _items
    End Get
  End Property

  Public ReadOnly Property Total() As Decimal
    Get
      Dim decAmount As Decimal
      For Each myOrderedProduct As OrderedProduct In _items
        decAmount += myOrderedProduct.SubTotal
      Next
      Return decAmount
    End Get
  End Property

  Public Sub Add(ByVal clsProduct As Product)
    For Each existingProduct As OrderedProduct In _items
      If clsProduct.ID = existingProduct.ProductID Then
        existingProduct.Quantity += 1
        Exit Sub
      End If
    Next
    Dim clsOrderedProduct As New OrderedProduct(clsProduct, 1)
    _items.Add(clsOrderedProduct)
  End Sub

  Public Sub Update(ByVal intQuantity As Integer, ByVal id As Guid)
    For Each existingProduct As OrderedProduct In _items
      If existingProduct.ID = id Then
        existingProduct.Quantity = intQuantity
      End If
    Next
  End Sub

  Public Sub Remove(ByVal id As Guid)
    For Each existingProduct As OrderedProduct In _items
      If id = existingProduct.ID Then
        _items.Remove(existingProduct)
        Exit For
      End If
    Next
  End Sub

  Public Sub Clear()
    _items.Clear()
  End Sub

End Class
